//
//  hGł Version1.10
//
//     2003/10/ 1 ˁ@P
//

unit Unit1;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls, Buttons, ExtCtrls, ComCtrls, Menus, ExtDlgs;

type
  TForm1 = class(TForm)
    btPen: TSpeedButton;
    btFill: TSpeedButton;
    Panel2: TPanel;
    UpDown1: TUpDown;
    edPSize: TEdit;
    imgPal: TImage;
    MainMenu1: TMainMenu;
    F1: TMenuItem;
    mSave: TMenuItem;
    N1: TMenuItem;
    BMPSaveDialog: TSavePictureDialog;
    pLb: TPanel;
    pRb: TPanel;
    pLbn: TPanel;
    pRbn: TPanel;
    mLoad: TMenuItem;
    BMPLoadDialog: TOpenPictureDialog;
    pMap: TPanel;
    scMap: TScrollBox;
    imgMap: TImage;
    N2: TMenuItem;
    mR2: TMenuItem;
    mR4: TMenuItem;
    mExit: TMenuItem;
    mAbout: TMenuItem;
    mR1: TMenuItem;
    Tool1: TMenuItem;
    mUP: TMenuItem;
    mDown: TMenuItem;
    mNorth: TMenuItem;
    mRight: TMenuItem;
    mSouth: TMenuItem;
    mWest: TMenuItem;
    procedure imgMapMouseDown(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
    procedure FormCreate(Sender: TObject);
    procedure imgPalMouseDown(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
    procedure btFillClick(Sender: TObject);
    procedure mSaveClick(Sender: TObject);
    procedure imgMapMouseMove(Sender: TObject; Shift: TShiftState; X,
      Y: Integer);
    procedure UpDown1Click(Sender: TObject; Button: TUDBtnType);
    procedure mLoadClick(Sender: TObject);
    procedure mR4Click(Sender: TObject);
    procedure mExitClick(Sender: TObject);
    procedure mAboutClick(Sender: TObject);
    procedure ToolMenuClick(Sender: TObject);
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
  private
    iPSize,iMode,iSc:Integer;
    lbc,rbc:TColor;
    pals:array[0..255] of Integer;
    mBMP:TBitmap;
    { Private 錾 }
  public
    { Public 錾 }
  end;

var
  Form1: TForm1;

implementation

{$R *.DFM}

procedure TForm1.FormCreate(Sender: TObject);
var
  i,j:Integer;
begin

  for i:=0 to 30 do
    pals[i]:=RGB(0,i*4,i*8+12);

  pals[31]:=RGB(212,240,240);

  for i:=32 to 39 do
    pals[i]:=RGB((i-32)*24,255-(i-32)*8,224-(i-32)*24);

  for i:=40 to 47 do
    pals[i]:=RGB(191+(i-39)*8,192-(i-40)*10,0);

  for i:=48 to 63 do
    pals[i]:=RGB(255-(i-48)*8,(i-48)*8,(i-48)*8);

  for i:=64 to 127 do
    pals[i]:=RGB((i-63)*2+127,(i-63)*2+127,(i-63)*2+127);

  for i:=128 to 255 do
    pals[i]:=RGB(255,255,255-(i-128)*2);

  for i:=0 to 15 do
    for j:=0 to 15 do
    begin

      imgPal.Canvas.Brush.Color:=pals[j+i*16];
      imgPal.Canvas.FillRect(Rect(j*12,i*12,j*12+12,i*12+12));

    end;

  mBMP:=TBitmap.Create;
  mBMP.Width:=257;
  mBMP.Height:=257;

  mBMP.Canvas.Brush.Color:=pals[31];
  mBMP.Canvas.FillRect(Rect(0,0,257,257));
  imgMap.Canvas.StretchDraw(Rect(0,0,514,514),mBMP);

  iPSize:=4;
  lbc:=31;
  rbc:=30;
  iSc:=2;

  pLb.Color:=pals[lbc];
  pRb.Color:=pals[rbc];
  pLbn.Caption:=IntToStr(lbc);
  pRbn.Caption:=IntToStr(rbc);

  if (imgPal.Canvas.Pixels[175,190] and $ffffff)<> $03ffff then
  begin

    ShowMessage('̃\tǵAtJ[ȊOł͎sł܂');
    Application.Terminate;

  end;

end;

procedure TForm1.imgMapMouseDown(Sender: TObject; Button: TMouseButton;
  Shift: TShiftState; X, Y: Integer);
var
  sx,sy,ex,ey:Integer;
  cc:TColor;
begin

  x:=x div iSc;
  y:=y div iSc;

  if iMode=0 then
  begin

    if Shift=[ssLeft] then  // {^
      cc:=lbc
    else
      cc:=rbc;

    sx:=x-iPSize div 2;
    sy:=y-iPSize div 2;
    ex:=x+iPSize-1;
    ey:=y+iPSize-1;

    if iPSize=1 then
      mBMP.Canvas.Pixels[x,y]:=pals[cc]
    else
    begin

      mBMP.Canvas.Brush.Color:=pals[cc];
      mBMP.Canvas.FillRect(Rect(sx,sy,ex,ey));

    end;

  end
  else if iMode=1 then
  begin

    if Shift=[ssLeft] then  // {^
      cc:=lbc
    else
      cc:=rbc;

    mBMP.Canvas.Brush.Color:=pals[cc];
    mBMP.Canvas.FloodFill(x,y,imgMap.Canvas.Pixels[x,y],fsSurface);

  end;

  imgMap.Picture.Bitmap.Canvas.StretchDraw(Rect(0,0,257*iSc,257*iSc),mBMP);
  imgMap.Refresh;

end;

procedure TForm1.imgMapMouseMove(Sender: TObject; Shift: TShiftState; X,
  Y: Integer);
var
  cc,cn,sx,sy,ex,ey,i:Integer;
begin

  x:=x div iSc;
  y:=y div iSc;

  cc:=mBMP.Canvas.Pixels[x,y];

  cn:=0;

  for i:=0 to 255 do
    if pals[i]=cc then
    begin

      cn:=i;
      break;

    end;

  pMap.Caption:='('+IntToStr(x)+','+IntToStr(y)+')'+'-'+IntToStr(cn);

  if not(iMode=0) or (not(Shift=[ssLeft]) and not(Shift=[ssRight])) then
    Exit;

  if Shift=[ssLeft] then  // {^
    cc:=lbc
  else
    cc:=rbc;

  sx:=x-iPSize div 2;
  sy:=y-iPSize div 2;
  ex:=x+iPSize-1;
  ey:=y+iPSize-1;

  if iPSize=1 then
    mBMP.Canvas.Pixels[x,y]:=pals[cc]
  else
  begin

    mBMP.Canvas.Brush.Color:=pals[cc];
    mBMP.Canvas.FillRect(Rect(sx,sy,ex,ey));

  end;

  imgMap.Picture.Bitmap.Canvas.StretchDraw(Rect(0,0,257*iSc,257*iSc),mBMP);
  imgMap.Refresh;

end;

procedure TForm1.imgPalMouseDown(Sender: TObject; Button: TMouseButton;
  Shift: TShiftState; X, Y: Integer);
begin

  if Shift=[ssLeft] then  // {^
    lbc:=x div 12+(y div 12)*16
  else
    rbc:=x div 12+(y div 12)*16;

  pLb.Color:=pals[lbc];
  pRb.Color:=pals[rbc];
  pLbn.Caption:=IntToStr(lbc);
  pRbn.Caption:=IntToStr(rbc);

end;

procedure TForm1.btFillClick(Sender: TObject);
begin

  TSpeedButton(Sender).Down:=True;

  if Sender=btPen then
    iMode:=0
  else
    iMode:=1;

end;

procedure TForm1.mSaveClick(Sender: TObject);
var
  dwSize:DWORD;
  fhead:TBITMAPFILEHEADER;
  ihead:TBITMAPINFOHEADER;
  buf:Pointer;
  p:^BYTE;
  fh:FILE;
  i,j,k,cl,ofs,mc:Integer;
  wpal:array[0..255] of Integer;
begin

  buf:=AllocMem(sizeof(fhead)+sizeof(ihead)+1024+260*257);

  fhead.bfType:=77*256+66;
  fhead.bfSize:=sizeof(fhead)+sizeof(ihead)+1024+260*257;
  fhead.bfReserved1:=0;
  fhead.bfReserved2:=0;
  fhead.bfOffBits:=sizeof(fhead)+sizeof(ihead)+1024;

  ihead.biSize:=$28; // chawb_
  ihead.biWidth:=257;
  ihead.biHeight:=257;
  ihead.biPlanes:=1;
  ihead.biBitCount:=8;
  ihead.biCompression:=BI_RGB;
  ihead.biSizeImage:=0;
  ihead.biXPelsPerMeter:=0;
  ihead.biYPelsPerMeter:=0;
  ihead.biClrUsed:=0;
  ihead.biClrImportant:=0;

  CopyMemory(buf,@fhead,sizeof(fhead));
  CopyMemory(Ptr(Integer(buf)+sizeof(fhead)),@ihead,sizeof(ihead));

  for i:=0 to 255 do
    wpal[i]:=RGB(i,i,i);

  CopyMemory(Ptr(Integer(buf)+sizeof(fhead)+sizeof(ihead)),@wpal,1024);

  for i:=0 to 256 do
    for j:=0 to 256 do
    begin

      cl:=30;
      mc:=mBMP.Canvas.Pixels[j,i] and $ffffff;

      for k:=0 to 255 do
        if mc=pals[k] then
        begin

          cl:=k;
          break;

        end;


      ofs:=j+((257-1)-i)*260;
      p:=Ptr(Integer(buf)+sizeof(fhead)+sizeof(ihead)+1024+ofs);
      p^:=cl;

    end;

  if not(BMPSaveDialog.Execute) then
  begin

    FreeMem(buf);
    Exit;

  end;

  AssignFile(fh,BMPSaveDialog.FileName);

  Rewrite(fh,1);
  BlockWrite(fh,buf^,sizeof(fhead)+sizeof(ihead)+1024+260*257,dwSize);
  CloseFile(fh);

  FreeMem(buf);

end;

procedure TForm1.UpDown1Click(Sender: TObject; Button: TUDBtnType);
begin

  iPSize:=UpDown1.Position;

end;

procedure TForm1.mLoadClick(Sender: TObject);
var
  wBMP:TBitmap;
  i,j:Integer;
begin

  if not(BMPLoadDialog.Execute) then
    Exit;

  wBMP:=TBitmap.Create;
  wBMP.LoadFromFile(BMPLoadDialog.FileName);

  if (wBMP.Width<>257) or (wBMP.Height<>257) then
  begin

    ShowMessage('̃t@C͒n`f[^ł͂܂');
    Exit;

  end;

  for i:=0 to 256 do
    for j:=0 to 256 do
      mBMP.Canvas.Pixels[j,i]:=pals[wBMP.Canvas.Pixels[j,i] and $ff];

  wBMP.Free;
  
  imgMap.Canvas.StretchDraw(Rect(0,0,257*iSc,257*iSc),mBMP);
  imgMap.Refresh;

end;

procedure TForm1.mR4Click(Sender: TObject);
begin

  TMenuItem(Sender).Checked:=True;

  if Sender=mR1 then
  begin

    iSc:=1;
    scMap.AutoScroll:=False;

  end
  else if Sender=mR2 then
  begin

    iSc:=2;
    scMap.AutoScroll:=False;

  end
  else if Sender=mR4 then
  begin

    iSc:=4;
    scMap.AutoScroll:=True;

  end;

  imgMap.Width:=257*iSc;
  imgMap.Height:=257*iSc;
  imgMap.Picture.Bitmap.Width:=257*iSc;
  imgMap.Picture.Bitmap.Height:=257*iSc;

  imgMap.Canvas.StretchDraw(Rect(0,0,257*iSc,257*iSc),mBMP);
  imgMap.Refresh;

end;

procedure TForm1.mExitClick(Sender: TObject);
begin

  Application.Terminate;

end;

procedure TForm1.ToolMenuClick(Sender: TObject);
var
  i, j, k, cl, mc:Integer;
begin

  if Sender=mUP then
  begin

  for i:=0 to 256 do
    for j:=0 to 256 do
    begin

      cl := -1;
      mc := mBMP.Canvas.Pixels[j,i] and $00ffffff;

      for k:=0 to 255 do
        if mc=pals[k] then
        begin

          cl:=k;
          break;

        end;

      if (cl <> -1) and (cl < 255) then
        mBMP.Canvas.Pixels[j,i] := pals[k + 1];

    end;

  end
  else if Sender=mDown then
  begin

    for i:=0 to 256 do
      for j:=0 to 256 do
      begin

        cl:=-1;
        mc:=mBMP.Canvas.Pixels[j,i] and $00ffffff;

        for k:=0 to 255 do
          if mc=pals[k] then
          begin

            cl:=k;
            break;

          end;

        if cl > 0 then
          mBMP.Canvas.Pixels[j,i] := pals[k - 1];

      end;

  end
  else if Sender=mNorth then
  begin

    for i := 0 to 255 do
      for j := 0 to 256 do
        mBMP.Canvas.Pixels[j, i] := mBMP.Canvas.Pixels[j, i + 1];

  end
  else if Sender=mRight then
  begin

    for i := 0 to 256 do
      for j := 0 to 255 do
        mBMP.Canvas.Pixels[256 - j, i] := mBMP.Canvas.Pixels[256 - j - 1, i];

  end
  else if Sender=mSouth then
  begin

    for i := 0 to 255 do
      for j := 0 to 256 do
        mBMP.Canvas.Pixels[j, 256 - i] := mBMP.Canvas.Pixels[j, 256 - i - 1];

  end
  else if Sender=mWest then
  begin

    for i := 0 to 256 do
      for j := 0 to 255 do
        mBMP.Canvas.Pixels[j, i] := mBMP.Canvas.Pixels[j + 1, i];

  end;

  imgMap.Picture.Bitmap.Canvas.StretchDraw(Rect(0,0,257*iSc,257*iSc),mBMP);
  imgMap.Refresh;

end;

procedure TForm1.mAboutClick(Sender: TObject);
begin

  ShowMessage('hGł Version1.10 (C)1999-2003 ˁ@P');

end;

procedure TForm1.FormClose(Sender: TObject; var Action: TCloseAction);
begin

  mBMP.Free;

end;

end.
